"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantGroupLevelQuestions(ProtocolElement):
    """
    The variant group level questions
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "actionability",
        "clinicalUtility",
        "phenotypesSolved",
        "variantGroup",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "shortTandemRepeatLevelQuestions": reports_6_5_0.ShortTandemRepeatLevelQuestions,
            "structuralVariantLevelQuestions": reports_6_5_0.StructuralVariantLevelQuestions,
            "variantLevelQuestions": reports_6_5_0.VariantLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "actionability": reports_6_5_0.Actionability,
            "clinicalUtility": reports_6_5_0.ClinicalUtility,
            "phenotypesSolved": reports_6_5_0.PhenotypesSolved,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.Actionability": reports_6_5_0.Actionability,
            "org.gel.models.report.avro.ClinicalUtility": reports_6_5_0.ClinicalUtility,
            "org.gel.models.report.avro.PhenotypesSolved": reports_6_5_0.PhenotypesSolved,
            "org.gel.models.report.avro.ShortTandemRepeatLevelQuestions": reports_6_5_0.ShortTandemRepeatLevelQuestions,
            "org.gel.models.report.avro.StructuralVariantLevelQuestions": reports_6_5_0.StructuralVariantLevelQuestions,
            "org.gel.models.report.avro.VariantLevelQuestions": reports_6_5_0.VariantLevelQuestions,
            "org.gel.models.report.avro.VariantGroupLevelQuestions": reports_6_5_0.VariantGroupLevelQuestions,
        }

    __slots__ = [
        "actionability",
        "clinicalUtility",
        "phenotypesSolved",
        "variantGroup",
        "phenotypesExplained",
        "shortTandemRepeatLevelQuestions",
        "structuralVariantLevelQuestions",
        "variantLevelQuestions",
    ]

    def __init__(
        self,
        actionability,
        clinicalUtility,
        phenotypesSolved,
        variantGroup,
        phenotypesExplained=None,
        shortTandemRepeatLevelQuestions=None,
        structuralVariantLevelQuestions=None,
        variantLevelQuestions=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.VariantGroupLevelQuestions model.

        :param actionability:
            Is evidence for this variant/variant pair sufficient to use it for
            clinical purposes such as prenatal diagnosis or predictive
            testing?
        :type actionability: Actionability
        :param clinicalUtility:
            Has the clinical team identified any changes to clinical care which
            could potentially arise as a result of this
            variant/variant pair?
        :type clinicalUtility: list[ClinicalUtility]
        :param phenotypesSolved:
            Did you report the variant(s) as being partially or completely
            causative of the family's presenting phenotype(s)?
        :type phenotypesSolved: PhenotypesSolved
        :param variantGroup:
            This value groups variants that together could explain the phenotype
            according to the mode of inheritance used. (e.g.: compound
            heterozygous). All the variants in the same report sharing
            the same value will be considered in the same group (i.e.:
            reported together). This value is an integer unique in the
            whole report. These values are only relevant within the
            same report.
        :type variantGroup: int
        :param phenotypesExplained:
            If you indicated that the variant(s) only partially explained the
            family s presenting phenotypes, please indicate which HPO
            terms you are confident that they DO explain
        :type phenotypesExplained: None | list[str]
        :param shortTandemRepeatLevelQuestions:
            STR level questions for each of the variants in the group
        :type shortTandemRepeatLevelQuestions: None | list[ShortTandemRepeatLevelQuestions]
        :param structuralVariantLevelQuestions:
            Structural level questions for each of the variants in the group
        :type structuralVariantLevelQuestions: None | list[StructuralVariantLevelQuestions]
        :param variantLevelQuestions:
            Variant level questions for each of the variants in the group
        :type variantLevelQuestions: None | list[VariantLevelQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
